unit bangs;

interface

uses
  sliderapi,
  slider,
  vc_engine,
  Windows;

procedure RegisterBangs;
procedure UnRegisterBangs;

implementation

function AddBangCommand(command: string; f: Pointer): Boolean; cdecl; external lsapi;
function RemoveBangCommand(command: string): Boolean; cdecl; external lsapi;

Procedure toggle_slider(Caller:Integer;Args:pchar); cdecl;
Var
  group: Integer;
  Slider: PSlider;
Begin
  //onTop = !(GetWindowLong(hWnd, GWL_EXSTYLE) & WS_EX_TOPMOST);
  Group := Str2Int(Args);
  Slider := First_Slider;
  While ( Slider<>nil ) Do
  Begin
    If ( Slider^.groupID=Group) Then
    Begin
      If Slider^.visible then
        ShowWindow(Slider^.hMainWnd,SW_HIDE)
      Else
       ShowWindow(Slider^.hMainWnd,SW_SHOW);
      Slider^.Visible := NOT(Slider^.Visible)
    End;
    Slider := Slider^.Next_Slider;
  End;
End;

Procedure hide_slider(Caller:Integer;Args:pchar); cdecl;
Var
  group: Integer;
  Slider: PSlider;
Begin
  Group := Str2Int(Args);
  Slider := First_Slider;
  While ( Slider<>nil ) Do
  Begin
    If ( Slider^.groupID=Group )AND( Slider^.visible=True ) Then
      Begin
        ShowWindow(Slider^.hMainWnd,SW_HIDE);
        Slider^.visible := false;
      End;
    Slider := Slider^.Next_Slider;
  End;
End;

Procedure show_slider(Caller:Integer;Args:pchar); cdecl;
Var
  group: Integer;
  Slider: PSlider;
Begin
  Group := Str2Int(Args);
  Slider := First_Slider;
  While ( Slider<>nil ) Do
  Begin
    If ( Slider^.groupID=Group )AND( Slider^.visible=false ) Then
      Begin
        ShowWindow(Slider^.hMainWnd,SW_SHOW);
        Slider^.visible := true;
      End;
    Slider := Slider^.Next_Slider;
  End;
End;

Procedure slider_hook(Caller:Integer;Args:pchar); cdecl;
Var
  boxwnd: Hwnd;
begin
  boxwnd := Str2Int(StrRScan(Args,#32));
  //Msgbox(0,StrRScan(Args,#32)+':'+args);
  Create_Slider(boxwnd,'*hooked '+Args);
//     SetFlag(Calendar.Flags,isDocked,true);
end;

procedure Mute(Caller:Integer;Args:pchar); cdecl;
Var
  ch : Byte;
Begin
 ch := Str2Int(args);
    SetMute(ch,NOT(GetMute(ch)));
End;

procedure Set_Balance(Caller:Integer;Args:pchar); cdecl;
Var
  ch: Byte;
  balance : ShortInt;
Begin
  ch := Str2int(GetToken(args,1));
  balance := Str2int(GetToken(args,2));
  Change_Balance(ch,balance);
End;

procedure Balance_right(Caller:Integer;Args:pchar); cdecl;
Var
  ch: Byte;
  Left, Right : Integer;
  balance : ShortInt;
Begin
  ch := Str2int(GetToken(args,1));
  GetVolumeA(ch,left,right);
  If ( Right>Left ) Then
    balance := 100-(Left DIV (Right DIV 100))
  Else
    balance := -100+(Right DIV (Left DIV 100));
  Change_Balance(ch,balance+BalanceStepWidth);
end;

procedure Balance_left(Caller:Integer;Args:pchar); cdecl;
Var
  ch: Byte;
  Left, Right : Integer;
  balance : ShortInt;
Begin
  ch := Str2int(GetToken(args,1));
  GetVolumeA(ch,left,right);
  If ( Right>Left ) Then
    balance := 100-(Left DIV (Right DIV 100))
  Else
    balance := -100+(Right DIV (Left DIV 100));
  Change_Balance(ch,balance-BalanceStepWidth);
End;

procedure Set_Volume(Caller:Integer;Args:pchar); cdecl;
Var
  ch, Value : ShortInt;
Begin
  ch := Str2int(GetToken(args,1));
  Value := Str2int(GetToken(args,2));
  Change_Volume(ch,Value);
End;

procedure Volume_Down(Caller:Integer;Args:pchar); cdecl;
Var
  left,Right: Integer;
  ch, Volume: ShortInt;
begin
  ch := Str2Int(args);
  GetVolumeA(ch,left,right);
  If (Right>Left) Then
    Volume := (Right DIV 655)
  Else
    Volume := (Left DIV 655);
  Change_Volume(ch,Volume-VolumeStepWidth);
end;

procedure Volume_up(Caller:Integer;Args:pchar); cdecl;
Var
  left,Right: Integer;
  ch, Volume: ShortInt;
begin
  ch := Str2Int(args);
  GetVolumeA(ch,left,right);
  If (Right>Left) Then
    Volume := (Right DIV 655)
  Else
    Volume := (Left DIV 655);
  Change_Volume(ch,Volume+VolumeStepWidth);
end;

procedure RegisterBangs;
begin
  AddBangCommand('!ToggleSliderGroup',@toggle_slider);
  AddBangCommand('!HideSliderGroup',@Hide_slider);
  AddBangCommand('!ShowSliderGroup',@Show_slider);
  AddBangCommand('!SliderHook',@slider_hook);
  AddBangCommand('!SliderVolumeUp',@Volume_up);
  AddBangCommand('!SliderVolumeDown',@Volume_down);
  AddBangCommand('!SliderSetVolume',@Set_Volume);
  AddBangCommand('!SliderMute',@Mute);
  AddBangCommand('!SliderBalanceLeft',@Balance_left);
  AddBangCommand('!SliderBalanceRight',@Balance_right);
  AddBangCommand('!SliderSetBalance',@Set_Balance);
end;

procedure UnRegisterBangs;
begin
  RemoveBangCommand('!ToggleSliderGroup');
  RemoveBangCommand('!HideSliderGroup');
  RemoveBangCommand('!ShowSliderGroup');
  RemoveBangCommand('!SliderHook');
  RemoveBangCommand('!SliderVolumeUp');
  RemoveBangCommand('!SliderVolumeDown');
  RemoveBangCommand('!SliderSetVolume');
  RemoveBangCommand('!SliderMute');
  RemoveBangCommand('!SliderBalanceRight');
  RemoveBangCommand('!SliderBalanceLeft');
  RemoveBangCommand('!SliderSetBalance');
end;

end.
