unit sliderapi;

interface

Uses Windows,
     vc_engine;

Const
  Revision = '1.71';
  revId = 'Id: LsSlider.dpr,v '+Revision+' 2002/07/10 blkhawk';

  lsapi='lsapi.dll';
  WM_DESTROY = $0002;
  WM_PAINT = $000F;
  WM_ERASEBKGND = $0014;
  WM_MOUSEMOVE = $0200;
  WM_LBUTTONDOWN = $0201;
  WM_LBUTTONUP = $0202;
  WM_RBUTTONUP = $0205;
  WM_WINDOWPOSCHANGING = $0046;
  WM_NCHITTEST = $0084;
  WM_MOVING = 534;
  WM_RBUTTONDOWN = $0204;
  WM_MOUSELEAVE = $02A3;
  WM_USER = $0400;
  WM_TIMER = $0113;
  WM_SYSCOMMAND = $0112;
  WM_UPDATE = WM_USER + 98;
  WM_CHANGE = WM_USER + 99; 
  TTS_ALWAYSTIP = $01;
  TTF_SUBCLASS = $0010;
  TTM_DELTOOL = WM_USER + 5;
  LM_GETREVID = 9265;
  LM_REGISTERMESSAGE = 9263;
  LM_UNREGISTERMESSAGE = 9264;
  MAX_LINE_LENGTH = 4096;
  MM_MIXM_LINE_CHANGE = $3D0;
  MM_MIXM_CONTROL_CHANGE = $3D1;
  TRACKSET =  WM_USER + 13 ;
  TRACKGET =  WM_USER + 14 ;
  TRACKLENGTH = WM_USER + 17;
  PLAYING = WM_USER + 10;
  PAUSED = WM_USER + 11;


Type
  TType = (Horizontal, Vertical);
  TMode = (none, Volume, Balance, Winamp, WinampVol, Bangs, Foobar2000);
  //Toolinfo declaration for tooltips
  PToolInfo = ^TToolInfo;
  TToolInfo = packed record
                cbSize: UINT;
                uFlags: UINT;
                hwnd: HWND;
                uId: UINT;
                Rect: TRect;
                hInst: THandle;
                lpszText: PAnsiChar;
              end;

  PSlider = ^TSlider;
  TSlider = Record
              Typ: TType;
              Mode: TMode;
              Inverted,
              Visible,
              isDocked: Boolean;
              hMainWnd, //Main window handle
              ClientWnd: HWND; //Client (handle) window handle
              Timer: Integer; //Timer Handle
              BackDC,   //Background Memory Device Context
              HandDC: HDC;  //Handle Memory Device Context
              hxPos, hyPos, hoffs, hHeight,
              hWidth, channel, xPos, yPos, Height, Width: Integer;
              GroupID: Integer;
              Next_Slider,
              Prev_Slider: PSlider;
            End;


Var
  First_Slider: Pointer = nil;
  hwndWinamp: HWND = 0;
  hwndFoobar2000: HWND = 0;
  Hint_HWND: HWND = 0;
  Utility_HWND: HWND = 0;
  Inst: integer;
  VolumeStepWidth: integer = 10;
  BalanceStepWidth: integer = 10;

Function StrAlloc(Size: Cardinal): PChar;
Procedure StrDispose(Str: PChar);
Function Str2Int(s: String): Integer;
Function Int2Str(Value: Integer): String;
function StrLen(Str: PChar): Cardinal; assembler;
function StrCopy(Dest, Source: PChar): PChar; assembler;
function StrRScan(Str: PChar; Chr: Char): PChar; assembler;
function GetToken(Args: String;n: Byte): String;
Function CommandToken(Args: String;n: Byte): String;
Function UpStr(Str: String): String;
Function CheckFlag(Flags:String; Flag:Char):byte;
Function GetGroup(Flags: String): Integer;
Procedure CreateHint(Wnd: Hwnd;Txt: Pchar);
Procedure RemoveHint(Wnd: HWND);
Procedure CreateUtilityWnd;
Procedure DestroyUtilityWnd;
procedure MoveRect(Rect: PRect; xPos, yPos: integer);
Procedure MsgBox(Flags: integer; Msg: String);

//Litestep Functions
Function LCOpen(szPath: PChar): Integer; cdecl;
Function LCReadNextConfig(F: integer; szPrefix,szBuffer : Pchar; dwLength: integer): Boolean; cdecl;
Function GetRCInt(lpKeyName:PChar;nDefault:longint):longint; cdecl;
Function LCClose(F: integer): Boolean; cdecl;
Function LoadLSImage (szImage, szFile: PChar): HBitmap; cdecl;
function AddBangCommand(command: string; f: Pointer): Boolean; cdecl;
function RemoveBangCommand(command: string): Boolean; cdecl;
Procedure GetLSBitmapSize(hBitmap: Integer;Var x, y: Integer); cdecl;
Function BitmapToRegion (hBmp: Integer;cTransparentColor, cTolerance: Integer;xoffset, yoffset: Integer): HRGN; cdecl;
function GetLitestepWnd:HWND; cdecl;

implementation

procedure InitCommonControls; stdcall; external 'comctl32.dll';

Function StrAlloc(Size: Cardinal): PChar;
begin
  Inc(Size, SizeOf(Cardinal));
  GetMem(Result, Size);
  Cardinal(Pointer(Result)^) := Size;
  Inc(Result, SizeOf(Cardinal));
end;

Procedure StrDispose(Str: PChar);
begin
  if Str <> nil then
  begin
    Dec(Str, SizeOf(Cardinal));
    FreeMem(Str, Cardinal(Pointer(Str)^));
  end;
end;

function StrLen(Str: PChar): Cardinal; assembler;
asm
        MOV     EDX,EDI
        MOV     EDI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        MOV     EAX,0FFFFFFFEH
        SUB     EAX,ECX
        MOV     EDI,EDX
end;

function StrCopy(Dest, Source: PChar): PChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        MOV     ESI,EAX
        MOV     EDI,EDX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        MOV     EDI,ESI
        MOV     ESI,EDX
        MOV     EDX,ECX
        MOV     EAX,EDI
        SHR     ECX,2
        REP     MOVSD
        MOV     ECX,EDX
        AND     ECX,3
        REP     MOVSB
        POP     ESI
        POP     EDI
end;

function StrRScan(Str: PChar; Chr: Char): PChar; assembler;
asm
        PUSH    EDI
        MOV     EDI,Str
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        STD
        DEC     EDI
        MOV     AL,Chr
        REPNE   SCASB
        MOV     EAX,0
        JNE     @@1
        MOV     EAX,EDI
        INC     EAX
@@1:    CLD
        POP     EDI
end;

function Str2Int(s: String): Integer;
var
  i,c : integer;
  neg,rel : boolean;
  
Function Pot(b,e: integer):LongInt;
Begin
  If (e=0) then
    Pot := 1
  Else
    Pot := b * Pot(b,e-1);
End;

begin
  c := 0;neg := false;rel := false;
  for i := length(s)-1 downto 0 do
   begin
    case s[i+1] of
      '-' : neg := true;
      '~' : rel := true;
    end;
    if ( Ord(s[i+1]) in [48..57] ) then
      c := c + ( (ord(s[i+1])-48)*Pot(10,length(s)-i-1) );
   end;
   
  if ( rel ) then // Its a "real Negative number"
    Str2Int := c + 45255
  else
    if ( neg ) then
      if ( c=0 ) then
        Str2Int := 45255 //Magic Number for "-0"
      else //its a negative number
        Str2Int := c*(-1)
    else //a Positive number
      Str2Int := c;
End;


Function Int2Str(Value: Integer): String;
Begin
  If (value<0) then
    Int2Str := '~'+Int2Str(Value*(-1))
  else
    If not((Value DIV 10) = 0) then
      result := Int2Str(Value DIV 10) + Chr(48 + (Value MOD 10))
    else
      result := Chr(48 + (Value Mod 10));
end;


function GetToken(Args: String;n: Byte): String;
var
  a,e,i : integer;
  ch: char;
begin
  a := 1; e := 1; ch := #32;
  for i := 1 to n do
  begin
    if (ch=#34) then inc(e);
    ch := #32; a := e;
    while ((Args[a] in [#32,#9])and(Args[a]<>#0)) do inc(a);
    If (Args[a]=#34) then begin
      inc(a); ch := #34; end;
    e := a;
    while not(args[e] in [ch,#0]) do inc(e);
  end;
  if (e>a) then
    Result := Copy(Args,a,e-a)
  else
    Result := '';
end;

Function CommandToken(Args: String;n: Byte): String;
var
  a,e,i : integer;
  ch: char;
begin
  a := 0; e := 0;
  for i := 1 to n do
  begin
    a := e+1;
    ch := #32;
    while ((args[a] in [ch,#9])and(args[a]<>#0)) do inc(a);
    e := a;
    If (args[a]=#34) then
      begin
        ch := #34;
        inc(e);
      end;
    while not(args[e] in [ch,#0]) do inc(e);
  end;
  if (e>a) then
    Result := Copy(Args,a,MAX_LINE_LENGTH)
  else
    Result := '';
end;

Function UpStr(Str: String): String;
Var
  Pos: Integer;
  UStr: String;
Begin
  UStr := Str;
  For Pos := 1 to length(UStr) Do
    if (UStr[pos] >= 'a') and (UStr[pos] <= 'z') then Dec(UStr[pos], 32);
  Result := UStr;
End;

Function CheckFlag(Flags:String; Flag:Char):byte;
Var
  i: integer;
Begin
  Result := 0;
  For i:= 1 to Length(Flags) do
    If ( UpCase(Flags[i])=Flag ) Then
      Result := i;
End;

Function GetGroup(Flags: String): Integer;
Var
  b,e: integer;
Begin
  b := CheckFlag(Flags,'#');
  If Boolean(b) then
  Begin
    e := b+1;
    While (e<Length(Flags))AND(Flags[e+1]<':')AND(Flags[e+1]>'/') do Inc(e);
    Result := Str2Int( Copy(Flags,b+1,e-1) );
  End Else
    Result := 0;
End;

Procedure CreateHint(Wnd: Hwnd;Txt: Pchar);
Const
  TTM_ADDTOOL = WM_USER + 4;
Var
  Ti: TToolInfo;
Begin
  If Hint_HWND=0 Then
  Begin
    InitCommonControls;
    Hint_HWND := CreateWindowEx(0,
       'Tooltips_class32', nil, TTS_ALWAYSTIP,
       CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
       CW_USEDEFAULT, 0, 0, hinstance, nil);
    If Hint_HWND=0 then
      MessageboxA(0,'Error Creating Tooltip Control',nil,0);
    SetWindowPos(Hint_HWND,HWND_TOPMOST,CW_USEDEFAULT,
      CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,SWP_NOMOVE+SWP_NOSIZE+SWP_NOACTIVATE);
  end;
  Ti.cbSize := SizeOf(TToolInfo);
  Ti.uFlags := TTF_SUBCLASS;
  Ti.hInst := hInstance;
  Ti.hwnd := wnd;
  Ti.uId := 0;
  GetClientRect(Wnd, Ti.rect);
  Ti.lpszText := txt;
  SendMessage(Hint_HWND,TTM_ADDTOOL,0,Integer(@Ti))
End;

Procedure RemoveHint(Wnd: HWND);
Var
  Ti: TToolInfo;
Begin
  ti.cbSize := sizeof(TTOOLINFO);
  ti.uFlags := 0;
  ti.hwnd := Wnd;
  ti.hinst := hInstance;
  ti.uId := 0;
  ti.lpszText := Nil;
  PostMessage(Hint_HWND,TTM_DELTOOL,0,Integer(@Ti));
End;


Function Utility_WndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Var
  Buffer: PChar;
  Slider: PSlider;
Begin
  Utility_WndProc := 0;
  Case Msg Of
   LM_GETREVID:  // Get our revision for '!About detailed'
       begin
         Buffer := PChar(lParam);
         if (wParam=0) then
           StrCopy(Buffer,PChar('LsSlider.dll: '+revision))
         else if (wParam=1) then
           StrCopy(Buffer,revId)
         else
           StrCopy(Buffer,'');
         result:=StrLen(Buffer);
      end;
   MM_MIXM_CONTROL_CHANGE:
     begin
         Slider := First_Slider;
         While ( Slider<>nil ) Do
           begin
             If (lParam=Lines[Slider.channel].dwControlID) then
               PostMessage(Slider^.hMainwnd,WM_UPDATE,0,0);
             Slider := Slider^.Next_Slider;
           end;
     end;
     Else
       Utility_WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
  End;
End;

Procedure CreateUtilityWnd;
Var
  Msgs:array [0..1] of longint;
  wc: Twndclass;
begin
  If NOT GetClassInfo(Inst,'LsSUtilityClass',wc) then
  begin
    FillChar(wc,sizeof(wc), #0);
    wc.lpfnWndProc := @Utility_WndProc;
    wc.lpszClassName := 'LsSUtilityClass';
    wc.hInstance := Inst;
    RegisterClassA(wc);
  end;
  Utility_HWND := CreateWindowExA(
        WS_EX_TOOLWINDOW,'LsSUtilityClass','',
        WS_POPUP,0,0,0,0,0,0,Inst,nil);

  Msgs[0] := LM_GETREVID;
  Msgs[1] := 0;
  SendMessage(GetLitestepWnd, LM_REGISTERMESSAGE, Utility_HWND, Integer(@Msgs));
End;

Procedure DestroyUtilityWnd;
Var
  Msgs:array [0..1] of longint;
  wc: Twndclass;
Begin
  Msgs[0] := LM_GETREVID;
  Msgs[1] := 0;
  SendMessage(GetLitestepWnd, LM_UNREGISTERMESSAGE, Utility_HWND, Integer(@Msgs));
  DestroyWindow(Utility_HWND);
  If GetClassInfo(Inst,'LsSUtilityClass',wc) then
    UnregisterClass('LsSUtilityClass',Inst);
End;

procedure MoveRect(Rect: PRect; xPos, yPos: integer);
begin
  Rect.right := xPos+(Rect.right-Rect.left);
  Rect.left := xPos;
  Rect.bottom := yPos+(Rect.bottom-Rect.top);
  Rect.top := yPos;
end;

Procedure MsgBox(Flags: integer; Msg: String);
begin
  MessageBoxEx(0,PChar(Msg),'LsSlider Error',Flags,0);
end;

//Litestep Functions
Function LCOpen; external lsapi;
Function LCReadNextConfig; external lsapi;
function GetRCInt; external lsapi;
Function LCClose; external lsapi;
Function LoadLSImage; external lsapi;
function AddBangCommand; external lsapi;
function RemoveBangCommand; external lsapi;
Procedure GetLSBitmapSize; external lsapi;
Function BitmapToRegion; external lsapi;
function GetLitestepWnd; external lsapi;

end.
